;**********************************************************************
;    Filename:      swlevel.asm                                           *
;    Date:          2007/2/11                                         *
;    File Version:                                                    *
;**********************************************************************
 
         list      		p=12F683			; list directive to define processor
         #include 		<p12F683.inc>		; processor specific variable definitions
  
         __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTOSCIO
         
          
;***** VARIABLE DEFINITIONS
w_temp			EQU	0x20		; variable used for context saving 
status_temp		EQU	0x21		; variable used for context saving

wait_data		EQU	0x30		;wait data ram
taihi			EQU	0x31		;taihi data
out_data_1		EQU	0x32		;out data 1

in_data			EQU	0x36		;in data
d_count			EQU	0x37		;hyouji count data

wait_data_2		EQU	0x39		;wait data 2

tm0_setdata		EQU	0x63		;FFH-63H=156 156*128=19.968msec 

;**********************************************************************
		ORG 	    	0x000             ; processor reset vector
            goto    		main              ; go to beginning of program
 
            ORG     		0x004             ; interrupt vector location
            movwf	   	w_temp            ; save off current W register contents
            movf    		STATUS,w          ; move status register into W register
            movwf   	status_temp       ; save off contents of STATUS register
            ;---------------------------------------------------------------
            bcf 	    	INTCON,T0IF
            movlw		tm0_setdata
            movwf   	TMR0
             ;---------------------------------
int_end
            movf    		status_temp,w    ; retrieve copy of STATUS register
            movwf   	STATUS            ; restore pre-isr STATUS register contents
            swapf   		w_temp,f
            swapf   		w_temp,w          	; restore pre-isr W register contents
            retfie                    			; return from interrupt
;--------------------------------------------------------------------------
main
		call			osc_set
		call			ad_set
		call			port_set

		movlw		3fh
		movwf		GPIO

            call 		timer0_set
 
		movlw		0ffh
		movwf		out_data_1
		movwf		in_data
		
		call			set_dcount

;--------------------------------------
main_loop
		;--------------------------------- LED disp
		bsf			GPIO,0
		nop
		btfsc		out_data_1,0
		bcf			GPIO,0
		nop

		bsf			GPIO,1
		nop
		btfsc		out_data_1,1
		bcf			GPIO,1
		nop

		bsf			GPIO,2
		nop
		btfsc		out_data_1,2
		bcf			GPIO,2
		nop

		bsf			GPIO,5
		nop
		btfsc		out_data_1,5
		bcf			GPIO,5
		nop
		call			wait_10
		
		;---------------------------------
		decf		d_count,1
		btfss		STATUS,2
		goto		main_loop
		call			set_dcount
		;--------------------------------- AD start
		movlw		0dh
		movwf		ADCON0
		call			wait_20
		call			wait_20
		bsf			ADCON0,1
ch0_wait
		btfsc		ADCON0,1
		goto		ch0_wait
		movf		ADRESH,0
		movwf		in_data

		;----------------------------------henkan
		movf		in_data,0
		call			henkan1
		movwf		out_data_1
	
	
            goto    		main_loop
;-------------------------------------------------------------------------------

wait_20
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;-------------------------------------------------------------------------------
wait_10
		movlw		5h
		movwf		wait_data_2
wait_10_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_10_2
		return

wait_0
		movlw		0ffh
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;------------------------------------------------------------------------------
set_dcount
		movlw		0x10
		movwf		d_count
		return
;-------------------------------------------------------------------------------
henkan1
		movwf		taihi
		movlw		low(henkan1_table)
		addwf		taihi,1
		movlw		high(henkan1_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan1_table	;-----------
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------10		
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------20
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------30
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------40
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------50
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------60
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------70
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;---------------80
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		01h
		;--------------90
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		01h
		retlw		03h
		retlw		03h
		;--------------A0
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		07h
		;--------------B0
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		;--------------C0
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		;--------------D0
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		;--------------E0
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		;--------------F0
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		27h

;-------------------------------------------------------------------------------

 ;------------------------------------------------------------------------------
osc_set
		bsf			STATUS,RP0
								;(0)NC
								;(110)IRCF2-IRCF0 4MHz
								;(0)OSTS
								;(1)HTS
								;(0)LTS
								;(1)SCS
		movlw		65h
		movwf		OSCCON
		bcf			STATUS,RP0
		return
 ;-------------------------------------------------------------------------------
port_set							
								;GP0,GP1,GP2,GP5(OUT)
								;GP3(IN)
								;GP4(IN)
		bsf			STATUS,RP0
		movlw		18h			;(00)NC
								;(01)TRISIO5,TRISIO4
								;(1)TRISIO3
								;(000)TRISIO2,TRISIO1,TRISIO0
		movwf		TRISIO
		bcf			STATUS,RP0
		return
 ;------------------------------------------------------------------------------
ad_set

								;(0)NC
								;(0)COUT
								;(0)NC
								;(0)CINV
								;(0)CIS
								;(111)CM
		movlw		07h
		movwf		CMCON0

		movlw		0dh			;(0)ADFM
								;(0)VCFG
								;(00)NC
								;(11)CHS1,CHS0
								;(0)GO
								;(1)ADON
		movwf		ADCON0

		bsf			STATUS,RP0
								
		movlw		18h			;(0)NC
								;(001)ADCS2,ADCS1,ADCS0
								;(1000)ANS3,ANS2,ANS1,ANS0
		movwf		ANSEL
		bcf			STATUS,RP0
		return
;------------------------------------------------------------------------------
timer0_set

		bsf			STATUS,RP0
		movlw		86h			;(1)GPIO PULLUP
								;(0)INTEDG
								;(0)TOCS
								;(0)TOSE
								;(0)PSA
								;(110)PS2,PS1,PS0 1/128
		movwf		OPTION_REG
		bcf			STATUS,RP0

		movlw		tm0_setdata
		movwf		TMR0
		bsf			INTCON,T0IE
		bcf			INTCON,GIE
		return
;-------------------------------------------------------------------------------
 
            END                     ; directive 'end of program'
